function Scorecard:SetupFrames()
	if self.frame then self.frame:Show(); return; end
	self.frame = CreateFrame("Frame", "ScorecardFrame", UIParent, MerchantFrame)
	self.frame:Hide()
	self.frame:EnableMouse(true)
	self.frame:SetFrameStrata("MEDIUM")
	self.frame:SetMovable(true)
	self.frame:SetWidth(360)
    self.frame:SetHeight(550)
	self.frame.textures = {}
	self.frame.textures.icon = self.frame:CreateTexture()
	SetPortraitToTexture(self.frame.textures.icon, "Interface\\Icons\\INV_Scroll_02")
	self.frame.textures.icon:SetWidth(58)
	self.frame.textures.icon:SetHeight(58)
	self.frame.textures.icon:SetTexCoord(0.0625, 0.9, 0.0652, 0.9)
	self.frame.textures.icon:SetPoint("TOPLEFT", self.frame, "TOPLEFT", 7, -6)	
	self.frame.textures.icon:SetDrawLayer("BORDER")
	self.frame.textures.topleft = self.frame:CreateTexture()
	self.frame.textures.topleft:SetTexture("Interface/PaperDollInfoFrame/UI-Character-General-TopLeft")
	self.frame.textures.topleft:SetPoint("TOPLEFT", self.frame, "TOPLEFT")
	self.frame.textures.topright = self.frame:CreateTexture()
	self.frame.textures.topright:SetTexture("Interface/PaperDollInfoFrame/UI-Character-General-TopRight")
	self.frame.textures.topright:SetPoint("TOPLEFT", self.frame.textures.topleft, "TOPRIGHT")
	self.frame.textures.bottomleft = self.frame:CreateTexture()
	self.frame.textures.bottomleft:SetTexture("Interface/PaperDollInfoFrame/UI-Character-General-BottomLeft")
	self.frame.textures.bottomleft:SetPoint("TOPLEFT", self.frame.textures.topleft, "BOTTOMLEFT")
	self.frame.textures.bottomright = self.frame:CreateTexture()
	self.frame.textures.bottomright:SetTexture("Interface/PaperDollInfoFrame/UI-Character-General-BottomRight")
	self.frame.textures.bottomright:SetPoint("TOPLEFT", self.frame.textures.topleft, "BOTTOMRIGHT")
	--Title
	self.frame.title = self.frame:CreateFontString("$parentTitle", "OVERLAY", "GameFontNormal");
	self.frame.title:SetPoint("TOPLEFT", self.frame, "TOPLEFT", 150,-16)
	self.frame.title:SetText("Scorecard")
	--Mover Frame
	self.mover = CreateFrame("Frame", nil, self.frame)
	self.mover:SetPoint("TOPLEFT", self.frame, "TOPLEFT")
	self.mover:EnableMouse(true)
	self.mover:SetWidth(330)
	self.mover:SetHeight(45)
	self.mover:SetFrameStrata("HIGH")
	--Close Button
	self.frame.close = CreateFrame("Button", "$parentCloseButton", self.frame, "UIPanelCloseButton")
	self.frame.close:SetPoint("TOPRIGHT", self.frame.textures.topright, "TOPRIGHT", -30, -8)
	--Options Button
	self.frame.options = CreateFrame("Button", "$parentOptionButton", self.frame)
	self.frame.options:SetHeight(32)
	self.frame.options:SetWidth(32)
	self.frame.options:SetPoint("TOPRIGHT", self.frame.textures.topright, "TOPRIGHT", -43, -43)
	self.frame.options:SetNormalTexture("Interface/Buttons/UI-GroupLoot-Dice-Up")
	self.frame.options:SetPushedTexture("Interface/Buttons/UI-GroupLoot-Dice-Down")
	self.frame.options:SetHighlightTexture("Interface/Buttons/UI-GroupLoot-Dice-Highlight", "ADD")
	self.frame.options:SetScript("OnClick", function()
		self:OpenMenu()
		end)
	self.frame.options:Show()
	--Reference Fontstring
	self.frame.reference = self.frame:CreateFontString(nil, "BORDER", "GameFontNormal")
	self.frame.reference:SetText("...")	
	--Tab Buttons: On top of window, switch between PvP, PvE, and Vulnerable Records.
	self.frame.buttons = {}
	for i=1, 3 do
		self.frame.buttons[i] = CreateFrame("Button", "$parentTab" .. i, self.frame, "TabButtonTemplate")
		self.frame.buttons[i]:Hide()
		self.frame.buttons[i]:SetID(i)
		self.frame.buttons[i]:SetScript("OnClick", function()
			FauxScrollFrame_SetOffset(self.frame.scroll, 0)
			self.SCROLLOFFSET = 0
			self:OnTabClick(i)
			self:ScrollUpdate()
		end)
		self.frame.buttons[i]:SetScript("OnShow", function()
			PanelTemplates_TabResize(0)
		end)
		self.frame.buttons[i]:SetText(self.tabtext[i])
		self.frame.buttons[i]:Show()
		if i == 1 then
			self.frame.buttons[i]:SetPoint("TOPLEFT", self.frame, "TOPLEFT", 70, -39)
		else
			self.frame.buttons[i]:SetPoint("LEFT", self.frame.buttons[i-1], "RIGHT")
		end
	end
	--Spell Buttons
	self.frame.spells = {}
	for i=1, 22 do
		self.frame.spells[i] = Scorecard:CreateSpellFrame("$parentSpellButton" .. i, self.frame)
		--self.frame.spells[1]:Hide()
		self.frame.spells[i]:SetID(i)
		self.frame.spells[i]:SetScript("OnClick", function()
				self:Print("clickSpell " .. i)
			end)
		self.frame.spells[i]:Show()
		if i == 1 then
			self.frame.spells[i]:SetPoint("TOPLEFT", self.frame, "TOPLEFT", 20, -76)
		else
			self.frame.spells[i]:SetPoint("TOPLEFT", self.frame.spells[i-1], "BOTTOMLEFT")
		end
	end
	--Info Frame
	self.frame.info = CreateFrame("Frame", "$parentInfoFrame", self.frame)
	self.frame.info:SetBackdrop( { 
      bgFile = "Interface/DialogFrame/UI-DialogBox-Background", 
      edgeFile = "Interface/DialogFrame/UI-DialogBox-Border", tile = true, tileSize = 32, edgeSize = 32, 
      insets = { left = 12, right = 12, top = 11, bottom = 11 }
    })
	self.frame.info:SetBackdropBorderColor(1,1,1,1)
	self.frame.info:SetBackdropColor(0,0,0,1)
	self.frame.info:SetPoint("TOPLEFT", self.frame, "TOPLEFT", 10, -440)
	self.frame.info:SetHeight(100)
	self.frame.info:SetWidth(340)
	--Info Frame Strings
		--Labels
	self.frame.info.timeLabel	= self.frame.info:CreateFontString("$parenttimeLabel", "BORDER", "GameFontNormal");
	self.frame.info.targetLabel	= self.frame.info:CreateFontString("$parenttargetLabel", "BORDER", "GameFontNormal");
	self.frame.info.amountLabel	= self.frame.info:CreateFontString("$parentamountLabel", "BORDER", "GameFontNormal");
	self.frame.info.hitLabel	= self.frame.info:CreateFontString("$parenthitLabel", "BORDER", "GameFontNormal");
	self.frame.info.critLabel	= self.frame.info:CreateFontString("$parentcritLabel", "BORDER", "GameFontNormal");
		--Info Text
	self.frame.info.hitTime    = self.frame.info:CreateFontString("$parenthitTime", "BORDER", "GameFontNormal");
	self.frame.info.hitTarget  = self.frame.info:CreateFontString("$parenthitTarget", "BORDER", "GameFontNormal");
	self.frame.info.hitAmount  = self.frame.info:CreateFontString("$parenthitAmount", "BORDER", "GameFontNormal");
	self.frame.info.critTime   = self.frame.info:CreateFontString("$parentcritTime", "BORDER", "GameFontNormal");
	self.frame.info.critTarget = self.frame.info:CreateFontString("$parentcritTarget", "BORDER", "GameFontNormal");
	self.frame.info.critAmount = self.frame.info:CreateFontString("$parentcritAmount", "BORDER", "GameFontNormal");
		--Positions
	self.frame.info.timeLabel:	SetPoint("TOPRIGHT", self.frame.info, "TOPRIGHT",	-70, -35)
	self.frame.info.targetLabel:SetPoint("TOPLEFT",	 self.frame.info, "TOPLEFT",	 50, -35)
	self.frame.info.amountLabel:SetPoint("TOPRIGHT", self.frame.info, "TOPRIGHT",	-13, -35)	
	self.frame.info.hitLabel:	SetPoint("TOPRIGHT", self.frame.info, "TOPLEFT",	 40, -50)	
	self.frame.info.critLabel:	SetPoint("TOPRIGHT", self.frame.info, "TOPLEFT",	 40, -65)	
	self.frame.info.hitTime:	SetPoint("TOPRIGHT", self.frame.info, "TOPRIGHT",	-70, -50)
	self.frame.info.hitTarget:	SetPoint("TOPLEFT",	 self.frame.info, "TOPLEFT", 	 50, -50)
	self.frame.info.hitAmount:	SetPoint("TOPRIGHT", self.frame.info, "TOPRIGHT",	-13, -50)
	self.frame.info.critTime:	SetPoint("TOPRIGHT", self.frame.info, "TOPRIGHT",	-70, -65)
	self.frame.info.critTarget:	SetPoint("TOPLEFT",	 self.frame.info, "TOPLEFT",	 50, -65)
	self.frame.info.critAmount:	SetPoint("TOPRIGHT", self.frame.info, "TOPRIGHT",	-13, -65)
		--Text
	self.frame.info.timeLabel:	SetText("Timestamp")
	self.frame.info.targetLabel:SetText("Target")
	self.frame.info.hitLabel:	SetText("Hit")
	self.frame.info.critLabel:	SetText("Crit")
	self.frame.info.amountLabel:SetText("Amount")
	self.frame.info.hitTime:	SetText("12/31/08 12:34:56")
	self.frame.info.hitTarget:	SetText("High Warlord Naj'entus")
	self.frame.info.hitAmount:	SetText("123456")
	self.frame.info.critTime:	SetText("12/31/08 12:34:56")
	self.frame.info.critTarget:	SetText("High Warlord Naj'entus")
	self.frame.info.critAmount:	SetText("654321")
		--Colors
	self.frame.info.timeLabel:	SetTextColor(1,1,1)
	self.frame.info.targetLabel:SetTextColor(1,1,1)
	self.frame.info.hitLabel:	SetTextColor(1,1,1)
	self.frame.info.critLabel:	SetTextColor(1,1,1)
	self.frame.info.amountLabel:SetTextColor(1,1,1)
		--Icon
	self.frame.info.spellButton = CreateFrame("Button", "$parentSpellButton", self.frame.info)
	self.frame.info.spellButton:SetWidth(150)
	self.frame.info.spellButton:SetHeight(14)
	self.frame.info.spellButton:SetScript("OnClick", function()
	end)
	self.frame.info.spellButton.tex = self.frame.info.spellButton:CreateTexture()
	self.frame.info.spellButton.tex:SetPoint("LEFT", self.frame.info.spellButton, "LEFT")
	self.frame.info.spellButton.tex:SetHeight(14)
	self.frame.info.spellButton.tex:SetWidth(14)
	self.frame.info.spellButton.label	= self.frame.info.spellButton:CreateFontString("$parentLabel", "BORDER", "GameFontNormal");
	self.frame.info.spellButton.label:SetText("Hello World")
	self.frame.info.spellButton.label:SetPoint("LEFT",  self.frame.info.spellButton.tex, "RIGHT", 6,0)
	self.frame.info.spellButton:SetPoint("TOPLEFT", self.frame.info, "TOPLEFT", 13, -13)
	--Copy Button
	self.frame.info.copyButton = CreateFrame("Button", "$parentCopyButton", self.frame.info, "GameMenuButtonTemplate")
	self.frame.info.copyButton:SetText("Copy")
	self.frame.info.copyButton:SetWidth(60)
	self.frame.info.copyButton:SetPoint("TOPRIGHT", self.frame.info, "TOPRIGHT", -13, -13)
	self.frame.info.copyButton:SetScript("OnClick", function()
	end)
	--ScrollBar
	self.frame.scroll = CreateFrame("ScrollFrame", "$parentScrollBar", self.frame, "FauxScrollFrameTemplate")
	self.frame.scroll:SetPoint("TOPLEFT", self.frame, "TOPLEFT", 20, -76)
	self.frame.scroll:SetWidth(1)
	self.frame.scroll:SetPoint("BOTTOMRIGHT", self.frame, "BOTTOMRIGHT", -45, 120)
	self.frame.scroll:SetScript("OnShow", function()
		Scorecard:ScrollUpdate()
	end)
	self.frame.scroll:SetScript("OnVerticalScroll", function()
		FauxScrollFrame_OnVerticalScroll(16, function()
			Scorecard:ScrollUpdate() 
		end)
	end)
	self.frame:SetFrameStrata("HIGH")
	self.frame.scroll:Show()
	--Splash Frame
	self.splash = CreateFrame("MessageFrame", "$parentSplash", UIParent)
	self.splash:SetMovable(true)
	self.splash:SetWidth(GetScreenWidth())
	self.splash:SetHeight(100)
	self.splash:SetPoint("CENTER", UIParent, "BOTTOMLEFT", self.db.char.options.splash.left, self.db.char.options.splash.top)
	self.splash:SetFontObject(NumberFontNormalHuge)
	self.splash:SetFrameStrata("HIGH")
		--Stuff for moving Splash Frame
	self.splash.bg = CreateFrame("Frame", "$parentBG", self.splash)
	self.splash.bg:EnableMouse(true)
	self.splash.bg:SetAllPoints(self.splash)
	self.splash.bg:SetBackdrop( { 
      bgFile = "Interface/DialogFrame/UI-DialogBox-Background", 
	  tile = true, tileSize = 32, edgeSize = 32, 
      insets = { left = 12, right = 12, top = 11, bottom = 11 }
    })
	self.splash.bg:SetBackdropColor(1,0,0,0.5)
	self.splash.bg.title = self.splash.bg:CreateFontString("$parentBG", "BORDER", "GameFontNormal");
	self.splash.bg.title:SetText("Scorecard Splash Frame")
	self.splash.bg.title:SetPoint("TOP", self.splash.bg, "TOP")
	self.splash.bg.text = self.splash.bg:CreateFontString("$parentBG", "BORDER", "GameFontNormal");
	self.splash.bg.text:SetText("Drag to Move\nRight Click to Hide")
	self.splash.bg.text:SetPoint("BOTTOM", self.splash.bg, "BOTTOM")
	self.splash.bg:SetScript("OnMouseDown",function()
        if ( arg1 == "LeftButton" ) then
			self.splash:StartMoving()
		end
    end)
    self.splash.bg:SetScript("OnMouseUp",function()
        if ( arg1 == "LeftButton" ) then
			self.splash:StopMovingOrSizing()
			--self:Print(self.splash:GetBottom() + (self.splash:GetHeight()/2), self.splash:GetLeft() + (self.splash:GetWidth()/2))
			self.db.char.options.splash.top = self.splash:GetBottom() + (self.splash:GetHeight()/2)
			self.db.char.options.splash.left = self.splash:GetLeft() + (self.splash:GetWidth()/2)
		end
		if ( arg1 == "RightButton" ) then
			self.splash:StopMovingOrSizing()
			self.splash.bg:Hide()
		end		
    end)
	self.splash.bg:SetScript("OnHide",function() this:StopMovingOrSizing() end)
	self.splash.bg:Hide()
	--Frame
	self.frame:ClearAllPoints()
	self.frame:SetPoint("CENTER", WorldFrame, "CENTER", 0, 0)
	self.mover:SetScript("OnMouseDown",function()
        if ( arg1 == "LeftButton" ) then
			self.frame:StartMoving()
		end
    end)
    self.mover:SetScript("OnMouseUp",function()
        if ( arg1 == "LeftButton" ) then
			self.frame:StopMovingOrSizing()
		end
    end)
	self.frame:SetScript("OnShow", function()
		tinsert(UISpecialFrames,this:GetName())
		self:OnTabClick(PanelTemplates_GetSelectedTab(self.frame))
	end)
    self.frame:SetScript("OnHide",function() this:StopMovingOrSizing() end)
	PanelTemplates_SetNumTabs(self.frame, 3);
	PanelTemplates_SetTab(self.frame, 1)
	self.frame.info:Hide()
	--self.frame:Show()
end

function Scorecard:CreateSpellFrame(name, parent)
	virtualButton = CreateFrame("Button", name, parent)
	virtualButton:SetWidth(298)
	virtualButton:SetHeight(16)
	virtualButton.icon = virtualButton:CreateTexture()
	virtualButton.icon:SetWidth(14)
	virtualButton.icon:SetHeight(14)
	virtualButton.icon:SetPoint("TOPLEFT", virtualButton, "TOPLEFT", 10,-2)
	virtualButton.name = virtualButton:CreateFontString("$parentName", "BORDER", "GameFontNormal");
	virtualButton.name:SetPoint("TOPLEFT", virtualButton, "TOPLEFT", 30,-2)
	virtualButton.rank = virtualButton:CreateFontString("$parentRank", "BORDER", "GameFontNormal");
	virtualButton.rank:SetPoint("TOPLEFT", virtualButton, "TOPLEFT", 140,-2)
	virtualButton.hit = virtualButton:CreateFontString("$parentHit", "BORDER", "GameFontNormal");
	virtualButton.hit: SetPoint("TOPLEFT", virtualButton, "TOPLEFT", 196,-2)
	virtualButton.crit = virtualButton:CreateFontString("$parentCrit", "BORDER", "GameFontNormal");
	virtualButton.crit:SetPoint("TOPLEFT", virtualButton, "TOPLEFT", 250,-2)
	--virtualButton:SetNormalTexture("Interface/TargetingFrame/UI-StatusBar")
	virtualButton:SetHighlightTexture("Interface/FriendsFrame/UI-FriendsFrame-HighlightBar", "ADD")
	return virtualButton
end
